Index: FOIAVistA/tag/r/DRG_GROUPER-ICD--ICPT/ICDCODE.m
===================================================================
--- FOIAVistA/trunk/r/DRG_GROUPER-ICD--ICPT/ICDCODE.m	(revision 631)
+++ FOIAVistA/tag/r/DRG_GROUPER-ICD--ICPT/ICDCODE.m	(revision 636)
@@ -1,4 +1,4 @@
-ICDCODE ;DLS/DEK/KER/FJF - ICD CODE APIS ; 09/20/07 8:54am
- ;;18.0;DRG Grouper;**6,12,14,29**;Oct 20, 2000;Build 18
+ICDCODE ;DLS/DEK/KER - ICD CODE APIS ; 10/20/04 8:54am
+ ;;18.0;DRG Grouper;**6,12,14**;Oct 20, 2000;Build 1
  ;
  ; External References
@@ -6,37 +6,34 @@
  ;
 ICDDX(CODE,CDT,DFN,SRC) ; Return ICD Dx Code Info
- ;Input:
- ;  CODE  Code/IEN (required)
- ;    CDT  Date (default = TODAY)
- ;    DFN  Not in use
- ;    SRC  Source
- ;         0 = exclude local codes
- ;         1 = include local codes
- ;
- ;Output:
- ;  Returns an 19 piece string delimited by ^
- ;    1  IEN of code in ^ICD9(
- ;    2  ICD-9 Dx Code (#.01)
- ;    3  Id (#2)
- ;    4  Versioned Dx (67 multiple)
- ;    5  Unacceptable as Principal Dx (#101)
- ;    6  Major Dx Cat (#5)
- ;    7  MDC13 (5.5)
- ;    8  Compl/Comorb (#70)
- ;    9  ICD Expanded (#8) 1:Yes 0:No
- ;    10 Status (66 multiple)
- ;    11 Sex (#9.5)
- ;    12 Inactive Date (66 multiple)
- ;    13 MDC24 (#5.7)
- ;    14 MDC25 (#5.9)
- ;    15 Age Low (#14)
- ;    16 Age High (#15)
- ;    17 Activation Date (.01 of 66 multiple)
- ;    18 Message
- ;    19 Versioned Complication/Comorbidity (#103)
- ;
- ;    or
- ;
- ;    -1^Error Description
+ ;Input:   CODE  Code/IEN (required)
+ ;         CDT   Date (default = TODAY)
+ ;         DFN   Not in use
+ ;         SRC   Source
+ ;               0 = exclude local codes
+ ;               1 = include local codes
+ ;
+ ;Output:  Returns an 18 piece string delimited by ^
+ ;           1  IEN of code in ^ICD9(
+ ;           2  ICD-9 Dx Code (#.01)
+ ;           3  Id (#2)
+ ;           4  Versioned Dx (67 multiple)
+ ;           5  Unacceptable as Principal Dx (#101)
+ ;           6  Major Dx Cat (#5)
+ ;           7  MDC13 (5.5)
+ ;           8  Compl/Comorb (#70)
+ ;           9  ICD Expanded (#8) 1:Yes 0:No
+ ;          10  Status (66 multiple)
+ ;          11  Sex (#9.5)
+ ;          12  Inactive Date (66 multiple)
+ ;          13  MDC24 (#5.7)
+ ;          14  MDC25 (#5.9)
+ ;          15  Age Low (#14)
+ ;          16  Age High (#15)
+ ;          17  Activation Date (.01 of 66 multiple)
+ ;          18  Message
+ ;
+ ;           or
+ ;
+ ;         -1^Error Description
  ;
  N DATA,EFF,INV,MDC,DRGFY
@@ -45,45 +42,41 @@
  I CODE<1 Q INV
  I '$D(^ICD9(CODE)) Q INV
- I '$G(SRC),$P(^ICD9(CODE,0),U,8) Q "-1^VA LOCAL CODE SELECTED"
+ I '$G(SRC),$P(^ICD9(CODE,0),"^",8) Q "-1^VA LOCAL CODE SELECTED"
  S DATA=$G(^ICD9(CODE,0)) I '$L(DATA) Q "-1^NO DATA"
  S CDT=$S($G(CDT)="":$$DT^XLFDT,1:$$DTBR^ICDAPIU(CDT))
  S EFF=$$EFF^ICDSUPT(80,CODE,CDT)
- S $P(DATA,U,6)=$$VMDC^ICDREF(CODE)
- S $P(DATA,U,9)=$S(EFF<1:0,1:$P(EFF,U))
- S $P(DATA,U,11)=$P(EFF,U,2),$P(DATA,U,16)=$P(EFF,U,3)
- S $P(DATA,U,3)=$$VSTD(CODE,CDT)
- S $P(DATA,U,17)=$$MSG^ICDAPIU(CDT)
- S $P(DATA,U,18)=$S($$COMCOM(CODE,CDT)'=-1:$$COMCOM(CODE,CDT),1:"")
- Q CODE_U_DATA
- ;
+ S $P(DATA,"^",6)=$$VMDC^ICDREF(CODE)
+ S $P(DATA,"^",9)=$S(EFF<1:0,1:$P(EFF,"^"))
+ S $P(DATA,"^",11)=$P(EFF,"^",2),$P(DATA,"^",16)=$P(EFF,"^",3)
+ S $P(DATA,"^",3)=$$VSTD(CODE,CDT)
+ Q CODE_"^"_DATA_"^"_$$MSG^ICDAPIU(CDT)
+ ;           
 ICDOP(CODE,CDT,DFN,SRC) ; Return ICD Operation/Procedure Code Info
- ;Input:
- ;  CODE  ICD code or IEN format, (required)
- ;    CDT  Date (default = TODAY)
- ;    DFN  Not in use
- ;    SRC  Source
- ;           0 = exclude local codes
- ;           1 = include local codes
- ;
- ;Output:
- ;  Returns an 14 piece string delimited by ^
- ;    1  IEN of code in ^ICD9(
- ;    2  ICD-9 code (#.01)
- ;    3  Id (#2)
- ;    4  MDC24 (#5)
- ;    5  Versioned Oper/Proc (67 multiple)
- ;    6  <null>
- ;    7  <null>
- ;    8  <null>
- ;    9  ICD Expanded (#8) 1:Yes 0:No
- ;    10 Status (66 multiple)
- ;    11 Use with Sex (#9.5)
- ;    12 Inactive Date (66 multiple)
- ;    13 Activation Date (66 multiple)
- ;    14 Message
- ;
- ;    or
- ;
- ;    -1^Error Description
+ ; Input:   CODE  ICD code or IEN format, (required)
+ ;          CDT   Date (default = TODAY)
+ ;          DFN   Not in use
+ ;          SRC   Source
+ ;                0 = exclude local codes
+ ;                1 = include local codes
+ ;
+ ; Output:  Returns an 14 piece string delimited by ^
+ ;            1  IEN of code in ^ICD9(
+ ;            2  ICD-9 code (#.01)
+ ;            3  Id (#2)
+ ;            4  MDC24 (#5)
+ ;            5  Versioned Oper/Proc (67 multiple)
+ ;            6  <null>
+ ;            7  <null>
+ ;            8  <null>
+ ;            9  ICD Expanded (#8) 1:Yes 0:No
+ ;           10  Status (66 multiple)
+ ;           11  Use with Sex (#9.5)
+ ;           12  Inactive Date (66 multiple)
+ ;           13  Activation Date (66 multiple)
+ ;           14  Message
+ ;
+ ;           -or-
+ ;
+ ;          -1^Error Description
  ;
  N DATA,EFF,STR,INV
@@ -92,32 +85,30 @@
  I CODE<1 Q INV
  I '$D(^ICD0(CODE)) Q INV
- I '$G(SRC),$P(^ICD0(CODE,0),U,8) Q "-1^VA LOCAL CODE SELECTED"
+ I '$G(SRC),$P(^ICD0(CODE,0),"^",8) Q "-1^VA LOCAL CODE SELECTED"
  S DATA=$G(^ICD0(CODE,0)) I '$L(DATA) Q "-1^NO DATA"
  S CDT=$S($G(CDT)="":$$DT^XLFDT,1:$$DTBR^ICDAPIU(CDT))
  S EFF=$$EFF^ICDSUPT(80.1,CODE,CDT)
- S $P(DATA,U,9)=$S(EFF<1:0,1:$P(EFF,U))
- S $P(DATA,U,11,12)=$P(EFF,U,2,3)
- S $P(DATA,U,4)=$$VSTP(CODE,CDT)
- Q CODE_U_DATA_U_$$MSG^ICDAPIU(CDT)
+ S $P(DATA,"^",9)=$S(EFF<1:0,1:$P(EFF,"^"))
+ S $P(DATA,"^",11,12)=$P(EFF,"^",2,3)
+ S $P(DATA,"^",4)=$$VSTP(CODE,CDT)
+ Q CODE_"^"_DATA_"^"_$$MSG^ICDAPIU(CDT)
  ;
 ICDD(CODE,OUTARR,CDT) ; returns ICD description in array
- ;Input:
- ;  CODE   ICD Code or IEN (required)
- ;    ARY    Array Name for description
- ;           e.g. "ABC" or "ABC("TEST")"
- ;           Default = ^TMP("ICDD",$J)
- ;    CDT    Date (default = TODAY)
- ;
- ;Output:
- ;  #   Number of lines in array
- ;
- ;  @ARY(1:n) - Versioned Description (68 multiple)
- ;  @ARY(n+1) - blank
- ;  @ARY(n+1) - message: CODE TEXT MAY BE INACCURATE
- ;
- ;  or
- ;
- ;  -1^Error Description
- ;
+ ; Input:   CODE   ICD Code or IEN (required)
+ ;          ARY    Array Name for description 
+ ;                 e.g. "ABC" or "ABC("TEST")" 
+ ;                 Default = ^TMP("ICDD",$J)
+ ;          CDT    Date (default = TODAY)
+ ; 
+ ; Output:  #      Number of lines in array
+ ; 
+ ;          @ARY(1:n) - Versioned Description (68 multiple)
+ ;          @ARY(n+1) - blank
+ ;          @ARY(n+1) - message: CODE TEXT MAY BE INACCURATE
+ ; 
+ ;           or
+ ; 
+ ;          -1^Error Description
+ ;          
  ; ** NOTE - USER MUST INITIALIZE ^TMP("ICDD",$J), IF USED **
  ;
@@ -137,4 +128,5 @@
  I OUTARR="^TMP(""ICDD"",$J," K ^TMP("ICDD",$J)
  S I=0,N=0,CDT=$S($G(CDT)="":$$DT^XLFDT,1:$$DTBR^ICDAPIU(CDT))
+ ;S N=N+1,ARR=OUTARR_N_")",@ARR=$G(@(GLOB_CODE_",1)"))
  S N=N+1,ARR=OUTARR_N_")",@ARR=$$VLT(CODE,CDT,GLOB)
  S N=N+1,ARR=OUTARR_N_")",@ARR=" "
@@ -143,17 +135,17 @@
  ;
 CODEN(CODE,FILE) ; return ien of ICD code
- ;Input:
- ;  CODE - ICD code (required)
- ;  FILE - File Number to search for code
- ;          80 = ICD Dx file
- ;          80.1 = ICD Oper/Proc file
- ;
- ;Output:
- ;  ien~global root
+ ;
+ ; Input:
+ ;    CODE - ICD code (required)
+ ;    FILE - File Number to search for code
+ ;           80 = ICD Dx file
+ ;           80.1 = ICD Oper/Proc file
+ ;
+ ; Output: ien~global root
  ;    where global root is:
- ;      "^ICD9(" - File 80
- ;      "^ICD0(" - File 80.1
- ;  or
- ;  -1~error message
+ ;           "^ICD9(" - File 80
+ ;           "^ICD0(" - File 80.1
+ ;    -or-
+ ;         -1~error message
  ;
  I $G(CODE)="" Q "-1~NO CODE SELECTED"
@@ -162,10 +154,10 @@
  ;use FILE if passed
  I $G(FILE) D  Q Y_"~"_GLOB
- .S GLOB=$S(FILE=80:"^ICD9(",FILE=80.1:"^ICD0(",1:INV_"FILE")
- .I $E(GLOB)'=U S Y=-1,GLOB=INV_"FILE" Q
- .S Y=$S(CODE?1.9N:$$CODEZ(CODE,GLOB),1:$$CODEBA(CODE,GLOB))
+ . S GLOB=$S(FILE=80:"^ICD9(",FILE=80.1:"^ICD0(",1:INV_"FILE")
+ . I $E(GLOB)'="^" S Y=-1,GLOB=INV_"FILE" Q
+ . S Y=$S(CODE?1.9N:$$CODEZ(CODE,GLOB),1:$$CODEBA(CODE,GLOB))
  ;FILE not passed - report where found
  I CODE?1.9N S GLOB="^ICD9(",Y=$$CODEZ(CODE,GLOB) D  G CODENQ
- .I Y<1 S GLOB="^ICD0(",Y=$$CODEZ(CODE,GLOB)
+ . I Y<1 S GLOB="^ICD0(",Y=$$CODEZ(CODE,GLOB)
  S GLOB=$S(CODE?2N1"."1.3N:"^ICD0(",CODE?3N1".".3N!(CODE?1U2.3N1".".2N):"^ICD9(",1:-1)
  S Y=$S('GLOB:$$CODEBA(CODE,GLOB),1:-1)
@@ -174,17 +166,17 @@
  ;
 CODEC(CODE,FILE) ;return the ICD code of an ien
- ;Input:
- ;  CODE - IEN of ICD code    REQUIRED
- ;  FILE - File Number to search for code
- ;         80 = ICD Dx file
- ;         80.1 = ICD Oper/Proc file
- ;
- ;Output: ICD code, -1 if not found
+ ;  Input:
+ ;    CODE - IEN of ICD code    REQUIRED
+ ;    FILE - File Number to search for code
+ ;           80 = ICD Dx file
+ ;           80.1 = ICD Oper/Proc file
+ ;
+ ; Output: ICD code, -1 if not found
  ;
  S CODE=$G(CODE) Q:CODE'?1.9N -1
  N Y,GLOB
  I $G(FILE) D  Q Y
- .S GLOB=$S(FILE=80:"^ICD9(",FILE=80.1:"^ICD0(",1:-1)
- .S Y=$S(GLOB<0:-1,1:$$CODEZ(CODE,GLOB))
+ . S GLOB=$S(FILE=80:"^ICD9(",FILE=80.1:"^ICD0(",1:-1)
+ . S Y=$S(GLOB<0:-1,1:$$CODEZ(CODE,GLOB))
  ;FILE not passed - Search for 1st match
  S Y=$$CODEZ(CODE,"^ICD9(",1)
@@ -193,22 +185,11 @@
 CODEZ(CODE,ROOT,FLG) ; Based on IEN/root:
  N Y,ICDL            ; if 'FLG return code existence, else zero node - piece 1
- S Y=$P($G(@(ROOT_CODE_",0)")),U),ICDL=$L(Y) I ICDL,'$G(FLG) Q CODE
+ S Y=$P($G(@(ROOT_CODE_",0)")),"^"),ICDL=$L(Y) I ICDL,'$G(FLG) Q CODE
  Q $S('ICDL:-1,1:Y)
+ ;
 CODEBA(CODE,ROOT) ; Return IEN based on code/root
  N IEN
  S IEN=$O(@(ROOT_"""BA"","""_CODE_" "","""")"),-1)
  Q $S('IEN:-1,1:IEN)
- ;
-COMCOM(IEN,VDT) ; Return versioned complication/comorbidity
- ;returns a code for complication/comorbidity
- ;  0 - non-CC
- ;  1 - CC
- ;  2 - MCC
- ;  -1 - versioned CC not on file for date
- N CCDATE,CCIEN
- S CCDATE=$O(^ICD9(IEN,69,"B",VDT+.0001),-1)
- I CCDATE="" Q -1
- S CCIEN=$O(^ICD9(IEN,69,"B",CCDATE,""),-1)
- Q $P(^ICD9(IEN,69,CCIEN,0),U,2)
  ;
 VST(IEN,VDT,TYPE)     ; Versioned Short Text
@@ -218,20 +199,20 @@
 VSTD(IEN,VDT)  ; Versioned Short Text (Dx)
  N ICD0,ICDC,ICDI,STD,STI,ICDT,TXT S ICDI=+($G(IEN)) Q:+ICDI'>0 ""  Q:'$D(^ICD9(+ICDI)) ""
- S ICDT=$G(VDT) S:'$L(ICDT)!(+ICDT'>0) ICDT=$$DT^XLFDT Q:$P(ICDT,".",1)'?7N ""  S ICD0=$G(^ICD9(+ICDI,0)),ICDC=$P(ICD0,U,1) Q:'$L(ICDC) ""
+ S ICDT=$G(VDT) S:'$L(ICDT)!(+ICDT'>0) ICDT=$$DT^XLFDT Q:$P(ICDT,".",1)'?7N ""  S ICD0=$G(^ICD9(+ICDI,0)),ICDC=$P(ICD0,"^",1) Q:'$L(ICDC) ""
  S STD=$O(^ICD9("AST",(ICDC_" "),(ICDT+.000001)),-1)
  I +STD>0 D  Q:$L($G(TXT)) $G(TXT)
- .S STI=$O(^ICD9("AST",(ICDC_" "),STD,+ICDI," "),-1),TXT=$$TRIM($P($G(^ICD9(+ICDI,67,+STI,0)),U,2))
+ . S STI=$O(^ICD9("AST",(ICDC_" "),STD,+ICDI," "),-1),TXT=$$TRIM($P($G(^ICD9(+ICDI,67,+STI,0)),"^",2))
  S STD=$O(^ICD9(+ICDI,67,"B",0)) I +STD>0 D  Q:$L($G(TXT)) $G(TXT)
- .S STI=$O(^ICD9(+ICDI,67,"B",STD,0)),TXT=$$TRIM($P($G(^ICD9(+ICDI,67,+STI,0)),U,2))
- Q $$TRIM($P(ICD0,U,3))
+ . S STI=$O(^ICD9(+ICDI,67,"B",STD,0)),TXT=$$TRIM($P($G(^ICD9(+ICDI,67,+STI,0)),"^",2))
+ Q $$TRIM($P(ICD0,"^",3))
 VSTP(IEN,VDT) ; Versioned Short Text (Proc)
  N ICD0,ICDC,ICDI,STD,STI,ICDT,TXT S ICDI=+($G(IEN)) Q:+ICDI'>0 ""  Q:'$D(^ICD0(+ICDI)) ""
- S ICDT=$G(VDT) S:'$L(ICDT)!(+ICDT'>0) ICDT=$$DT^XLFDT Q:$P(ICDT,".",1)'?7N ""  S ICD0=$G(^ICD0(+ICDI,0)),ICDC=$P(ICD0,U,1) Q:'$L(ICDC) ""
+ S ICDT=$G(VDT) S:'$L(ICDT)!(+ICDT'>0) ICDT=$$DT^XLFDT Q:$P(ICDT,".",1)'?7N ""  S ICD0=$G(^ICD0(+ICDI,0)),ICDC=$P(ICD0,"^",1) Q:'$L(ICDC) ""
  S STD=$O(^ICD0("AST",(ICDC_" "),(ICDT+.000001)),-1)
  I +STD>0 D  Q:$L($G(TXT)) $G(TXT)
- .S STI=$O(^ICD0("AST",(ICDC_" "),STD,+ICDI," "),-1),TXT=$$TRIM($P($G(^ICD0(+ICDI,67,+STI,0)),U,2))
+ . S STI=$O(^ICD0("AST",(ICDC_" "),STD,+ICDI," "),-1),TXT=$$TRIM($P($G(^ICD0(+ICDI,67,+STI,0)),"^",2))
  S STD=$O(^ICD0(+ICDI,67,"B",0)) I +STD>0 D  Q:$L($G(TXT)) $G(TXT)
- .S STI=$O(^ICD0(+ICDI,67,"B",STD,0)),TXT=$$TRIM($P($G(^ICD0(+ICDI,67,+STI,0)),U,2))
- Q $$TRIM($P(ICD0,U,4))
+ . S STI=$O(^ICD0(+ICDI,67,"B",STD,0)),TXT=$$TRIM($P($G(^ICD0(+ICDI,67,+STI,0)),"^",2))
+ Q $$TRIM($P(ICD0,"^",4))
 VLT(IEN,VDT,TYPE) ; Version Description - Long Text
  Q:TYPE["ICD9(" $$VLTD($G(IEN),$G(VDT))
@@ -242,30 +223,30 @@
  S ICDI=+($G(IEN)) Q:+ICDI'>0 ""  Q:'$D(^ICD9(+ICDI)) ""
  S ICDT=$G(VDT) S:'$L(ICDT)!(+ICDT'>0) ICDT=$$DT^XLFDT Q:$P(ICDT,".",1)'?7N ""
- S ICD0=$G(^ICD9(+ICDI,0)),ICDC=$P(ICD0,U,1) Q:'$L(ICDC) ""
+ S ICD0=$G(^ICD9(+ICDI,0)),ICDC=$P(ICD0,"^",1) Q:'$L(ICDC) ""
  S STD=$O(^ICD9("ADS",(ICDC_" "),(ICDT+.000001)),-1)
  I +STD>0 D  Q:$L($G(TXT)) $G(TXT)
- .S STI=$O(^ICD9("ADS",(ICDC_" "),STD,+ICDI," "),-1)
- .S TXT=$$TRIM($P($G(^ICD9(+ICDI,68,+STI,1)),U,1))
+ . S STI=$O(^ICD9("ADS",(ICDC_" "),STD,+ICDI," "),-1)
+ . S TXT=$$TRIM($P($G(^ICD9(+ICDI,68,+STI,1)),"^",1))
  S STD=$O(^ICD9(+ICDI,68,"B",0))
  I +STD>0 D  Q:$L($G(TXT)) $G(TXT)
- .S STI=$O(^ICD9(+ICDI,68,"B",STD,0))
- .S TXT=$$TRIM($P($G(^ICD9(+ICDI,68,+STI,1)),U,1))
+ . S STI=$O(^ICD9(+ICDI,68,"B",STD,0))
+ . S TXT=$$TRIM($P($G(^ICD9(+ICDI,68,+STI,1)),"^",1))
  S TXT=$$TRIM($G(^ICD9(+ICDI,1))) Q:$L($G(TXT)) $G(TXT)
- Q $$TRIM($P(ICD0,U,3))
+ Q $$TRIM($P(ICD0,"^",3))
 VLTP(IEN,VDT) ; Versioned Description - Long Text (Proc)
  N ICD0,ICDC,ICDI,STD,STI,ICDT,TXT
  S ICDI=+($G(IEN)) Q:+ICDI'>0 ""  Q:'$D(^ICD0(+ICDI)) ""
  S ICDT=$G(VDT) S:'$L(ICDT)!(+ICDT'>0) ICDT=$$DT^XLFDT Q:$P(ICDT,".",1)'?7N ""
- S ICD0=$G(^ICD0(+ICDI,0)),ICDC=$P(ICD0,U,1) Q:'$L(ICDC) ""
+ S ICD0=$G(^ICD0(+ICDI,0)),ICDC=$P(ICD0,"^",1) Q:'$L(ICDC) ""
  S STD=$O(^ICD0("ADS",(ICDC_" "),(ICDT+.000001)),-1)
  I +STD>0 D  Q:$L($G(TXT)) $G(TXT)
- .S STI=$O(^ICD0("ADS",(ICDC_" "),STD,+ICDI," "),-1)
- .S TXT=$$TRIM($P($G(^ICD0(+ICDI,68,+STI,1)),U,1))
+ . S STI=$O(^ICD0("ADS",(ICDC_" "),STD,+ICDI," "),-1)
+ . S TXT=$$TRIM($P($G(^ICD0(+ICDI,68,+STI,1)),"^",1))
  S STD=$O(^ICD0(+ICDI,68,"B",0))
  I +STD>0 D  Q:$L($G(TXT)) $G(TXT)
- .S STI=$O(^ICD0(+ICDI,68,"B",STD,0))
- .S TXT=$$TRIM($P($G(^ICD0(+ICDI,68,+STI,1)),U,1))
+ . S STI=$O(^ICD0(+ICDI,68,"B",STD,0))
+ . S TXT=$$TRIM($P($G(^ICD0(+ICDI,68,+STI,1)),"^",1))
  S TXT=$$TRIM($G(^ICD0(+ICDI,1))) Q:$L($G(TXT)) $G(TXT)
- Q $$TRIM($P(ICD0,U,4))
+ Q $$TRIM($P(ICD0,"^",4))
 TRIM(X) ; Trim Spaces
  S X=$G(X) Q:X="" X F  Q:$E(X,1)'=" "  S X=$E(X,2,$L(X))
Index: FOIAVistA/tag/r/DRG_GROUPER-ICD--ICPT/ICDDRG.m
===================================================================
--- FOIAVistA/trunk/r/DRG_GROUPER-ICD--ICPT/ICDDRG.m	(revision 631)
+++ FOIAVistA/tag/r/DRG_GROUPER-ICD--ICPT/ICDDRG.m	(revision 636)
@@ -1,4 +1,4 @@
-ICDDRG ;ALB/GRR/EG/ADL - ASSIGNS DRG CODES ; 11/13/07 4:07pm
- ;;18.0;DRG Grouper;**2,7,10,14,20,31**;Oct 20, 2000;Build 7
+ICDDRG ;ALB/GRR/EG/ADL - ASSIGNS DRG CODES ; 5/19/05 12:52pm
+ ;;18.0;DRG Grouper;**2,7,10,14,20**;Oct 20, 2000;Build 1
  ;ADL - UPDATED FOR CSV;3/10/03
 TOP S (ICDDRG,ICDMDC,ICDRTC)=""
@@ -19,5 +19,5 @@
  I ICDTMP<0 S ICDRTC=1 G ERR
  S ICDY(0)=$P(ICDTMP,U,2,99) I $P(ICDY(0),"^",4)=1!($P(ICDY(0),"^",9)=0) S ICDRTC=1 G ERR  ;flag has changed from inactive flag to status flag
- S ICDMDC=$P(ICDY(0),"^",5),ICDPD=$P(ICDY(0),"^",2),ICDRG=0 I 'ICDMDC S ICDRTC=1 G ERR
+ S ICDMDC=$P(ICDY(0),"^",5),ICDPD=$P(ICDY(0),"^",2),ICDRG=0 I 'ICDMDC S ICDDRG=469,ICDRTC=1 G ERR
  D MDCG
  I $D(ICDMDC(12))!($D(ICDMDC(13))) S ICDMDC=$S(SEX="F":13,1:12) I SEX="" S ICDRTC=4 G ERR
@@ -30,5 +30,5 @@
  ;FOLLOWING ESTABLISHES SECONDARY DIAGNOSIS VARIABLES
  ;
- S (ICDCCT,ICDMCCT,ICDSD)="",ICDCC=0,ICDMCC=0,ICDI=1
+ S (ICDCCT,ICDSD)="",ICDCC=0,ICDI=1
  F ICDIZ=0:0 S ICDI=$O(ICDDX(ICDI)) Q:ICDI'>0  D  G:ICDRTC]"" ERR
  . S ICDTMP=$$ICDDX^ICDCODE(ICDDX(ICDI),ICDDATE) I ICDTMP<0!'($P(ICDTMP,U,10)) S ICDRTC=8 Q
@@ -37,5 +37,4 @@
  . D SEC,SEX9 G:ICDRTC]"" ERR
  S:$D(ICDCCT(1)) ICDCC=1 K ICDCCT
- S:$D(ICDMCCT(1)) ICDMCC=1 S:$D(ICDMCCT(2)) ICDMCC=2 K ICDMCCT
  ;********************************************************
  ;FOLLOWING ESTABLISHES OPERATION/PROCEDURE VARIABLES
@@ -47,8 +46,5 @@
  K ICDO24("N") G:ICDRTC]"" ERR
  G ^ICDDRG0
-SEC I ICDDATE>3070930.9 D
- .S ICDMCC=$S($D(^ICD9("ACC",ICDDX(ICDI),ICDDX(1))):0,$P(ICDY(0),"^",18)=2:2,($P(ICDY(0),"^",18)=1)&(ICDMCC'=2):1,1:ICDMCC),ICDMCCT(ICDMCC)=""
- E  D
- .S ICDCC=$S($D(^ICD9("ACC",ICDDX(ICDI),ICDDX(1))):0,$P(ICDY(0),"^",7)=1:1,1:ICDCC),ICDCCT(ICDCC)=""
+SEC S ICDCC=$S($D(^ICD9("ACC",ICDDX(ICDI),ICDDX(1))):0,$P(ICDY(0),"^",7)=1:1,1:ICDCC),ICDCCT(ICDCC)=""
  ;Group ICD identifiers in one variable
  S ICDSD=ICDSD_$P(ICDY(0),"^",2)
@@ -79,5 +75,5 @@
  ;translate specific identifiers into common symbol, check for symbol
  S ICD104=$S($P(ICDY(0),"^",2)["P":1,1:0),ICDNMDC($S($TR($P(ICDY(0),"^",2),"lqtrB","\\\\")["\":1,1:0))="" Q
-ERR S ICDDRG=$S(ICDDATE>3070930.9:999,1:470)
+ERR S ICDDRG=470
  Q  ;ERR
 SEX9 ;get sex for dx or proc
@@ -105,5 +101,5 @@
  Q 1
 KILL K ICD104,ICDJ,ICDJJ,ICDOCNT,ICDOR,ICDNOR,ICDP15,ICDPDRG,ICDRG,ICDSEX
- K ICDSDRG,ICDODRG,ICDCC,ICDMCC,ICDOP,ICDORNR,ICDORNI,ICDP24,ICDP25,ICDPD
+ K ICDSDRG,ICDODRG,ICDCC,ICDOP,ICDORNR,ICDORNI,ICDP24,ICDP25,ICDPD
  K ICDSD,ICDI,ICDK,ICDF,ICDFX,ICDFK,ICDY,ICDDXT,ICDIZ,ICDONR,ICDOPCT
  K ICD,ICDCC2,ICDCC3,ICDGH,ICDL39,ICDMAJ,ICDNMDC,ICDNSD,ICDORNA,ICDREF,ICDS25
Index: FOIAVistA/tag/r/DRG_GROUPER-ICD--ICPT/ICDDRG0.m
===================================================================
--- FOIAVistA/trunk/r/DRG_GROUPER-ICD--ICPT/ICDDRG0.m	(revision 631)
+++ FOIAVistA/tag/r/DRG_GROUPER-ICD--ICPT/ICDDRG0.m	(revision 636)
@@ -1,51 +1,42 @@
-ICDDRG0 ;ALB/GRR/EG/ADL - DRG GROUPER PROCESSING BEGINS ; 11/13/07 4:06pm
- ;;18.0;DRG Grouper;**1,2,7,10,14,17,20,24,27,30,31,32**;Oct 20, 2000;Build 9
+ICDDRG0 ;ALB/GRR/EG/ADL - DRG GROUPER PROCESSING BEGINS ; 5/16/05 9:05pm
+ ;;18.0;DRG Grouper;**1,2,7,10,14,17,20,24,27,30**;Oct 20, 2000;Build 5
  ;GROUPING PROCESS BEGINS
  ;
 GROUP ;
- I $D(ICDSEX(1))&($D(ICDSEX(2))) S ICDRTC=4,ICDDRG=$S(ICDDATE>3070930.9:999,1:470) G KILL^ICDDRG
- I ICDMDC'=14,ICDMDC'=17,ICDMDC'=18,ICDMDC'=19,ICDMDC'=20,ICDMDC'=23,ICDMDC'=15 D:ICDOPCT<2  I ((ICDDATE'>3070930.9)&("468^476^477"[ICDRG))!((ICDDATE>3070930.9)&("983^986^989"[ICDRG)) G END
+ I $D(ICDSEX(1))&($D(ICDSEX(2))) S ICDRTC=4,ICDDRG=470 G KILL^ICDDRG
+ I ICDMDC'=14,ICDMDC'=17,ICDMDC'=18,ICDMDC'=19,ICDMDC'=20,ICDMDC'=23,ICDMDC'=15 D:ICDOPCT<2  I "468^476^477"[ICDRG G END
+ . ;I ICDPD["M",ICDOR'["a" S ICDPDRG(344)="",ICDOPCT=0
  . I $D(ICDF) Q
  . I ICDPD["M",ICDOR'["y" S ICDOPCT=0 Q
- . I ICDDATE>3070930.9 D
- . . I ICDORNI["O",ICDNOR=ICDONR,ICDNOR>0,'$D(ICDPDRG(769)),ICDORNI'["p" S ICDRG=$S($D(ICDORNI("O")):983,ICDORNI["y":986,ICDORNI["z":989,1:983) Q
- . . I ICDOPNR S ICDRG=$S(ICDORNI["y":986,1:983),ICDOPNR=0 Q
- . E  D
- . . I ICDORNI["O",ICDNOR=ICDONR,ICDNOR>0,'$D(ICDPDRG(377)),ICDORNI'["p" S ICDRG=$S($D(ICDORNI("O")):468,ICDORNI["y":476,ICDORNI["z":477,1:468) Q
- . . I ICDOPNR S ICDRG=$S(ICDORNI["y":476,1:468),ICDOPNR=0 Q
+ .I ICDORNI["O",ICDNOR=ICDONR,ICDNOR>0,'$D(ICDPDRG(377)),ICDORNI'["p" S ICDRG=$S($D(ICDORNI("O")):468,ICDORNI["y":476,ICDORNI["z":477,1:468) Q
+ .I ICDOPNR S ICDRG=$S(ICDORNI["y":476,1:468),ICDOPNR=0 Q
  ;
  ;if number of non-extensive ORs eqs # OR, 477
  ;
- I ICDMDC'=14,ICDMDC'=17,ICDMDC'=18,ICDMDC'=19,ICDMDC'=20,ICDMDC'=23,ICDMDC'=15,ICDORNI'["y"&(ICDORNI'="")&(ICDORNI["z") D  I ((ICDDATE'>3070930.9)&(ICDRG=477))!((ICDDATE>3070930.9)&(ICDRG=989)) G END
+ I ICDMDC'=14,ICDMDC'=17,ICDMDC'=18,ICDMDC'=19,ICDMDC'=20,ICDMDC'=23,ICDMDC'=15,ICDORNI'["y"&(ICDORNI'="")&(ICDORNI["z") D  I ICDRG=477 G END
  . I $D(ICDF) Q
- . NEW K S K=$$ORNI(ICDORNI) I K=ICDOPCT S ICDRG=$S(ICDDATE>3070930.9:989,1:477) Q
+ . NEW K S K=$$ORNI(ICDORNI) I K=ICDOPCT S ICDRG=477 Q
  ;
  ;if number of non-extensive ORs+prostatics eqs # OR, 476
  ;
- I ICDMDC'=14,ICDMDC'=17,ICDMDC'=18,ICDMDC'=19,ICDMDC'=20,ICDMDC'=23,ICDMDC'=15,ICDORNI["y"&(ICDORNI'="") D  I ((ICDDATE'>3070930.9)&(ICDRG=476))!((ICDDATE>3070930.9)&(ICDRG=986)) G END
- .N K S K=$$ORNI(ICDORNI) I K=ICDOPCT&(ICDNOR=ICDONR) S ICDRG=$S(ICDDATE>3070930.9:986,1:476) Q
- I ICDMDC'=14,ICDMDC'=17,ICDMDC'=18,ICDMDC'=19,ICDMDC'=20,ICDMDC'=23,ICDMDC'=15,ICDNOR=ICDONR&(ICDOPCT>0) S ICDRG=$S(ICDDATE>3070930.9:983,1:468) G END
- I ICDMDC=5,ICDOR'["O" S ICDRTC=$S(ICDEXP="":5,1:"") S:ICDRTC'="" ICDRG=$S(ICDDATE>3070930.9:999,1:470) D:ICDRTC="" MI G END
+ I ICDMDC'=14,ICDMDC'=17,ICDMDC'=18,ICDMDC'=19,ICDMDC'=20,ICDMDC'=23,ICDMDC'=15,ICDORNI["y"&(ICDORNI'="") D  I ICDRG=476 G END
+ .N K S K=$$ORNI(ICDORNI) I K=ICDOPCT&(ICDNOR=ICDONR) S ICDRG=476 Q
+ I ICDMDC'=14,ICDMDC'=17,ICDMDC'=18,ICDMDC'=19,ICDMDC'=20,ICDMDC'=23,ICDMDC'=15,ICDNOR=ICDONR&(ICDOPCT>0) S ICDRG=468 G END
+ I ICDMDC=5,ICDOR'["O" S ICDRTC=$S(ICDEXP="":5,1:"") S:ICDRTC'="" ICDRG=470 D:ICDRTC="" MI G END
  ;I ICDMDC=18,ICDOR["O"!(ICDORNI["O") S ICDRG=415 G END  ;;disabled by ICD*18*24 and new DRGs 578/579 - see ICDTLB6C
- I ICDMDC=19,ICDOCNT>0,ICDOR["O" S (ICDRG,HICDRG)=$S(ICDDATE>3070930.9:876,1:424) D CKDRG
- I ICDMDC=23,ICDOR["O"!(ICDORNI["O") S ICDRG=$S(ICDDATE>3070930.9:941,1:461) G END
+ I ICDMDC=19,ICDOCNT>0,ICDOR["O" S (ICDRG,HICDRG)=424 D CKDRG
+ I ICDMDC=23,ICDOR["O"!(ICDORNI["O") S ICDRG=461 G END
  I ICDMDC=14 D ^ICDDRG14 I ICDRG]"" G END
- I ICDMDC=20 S ICDRTC=$S(ICDDMS="":7,1:"") I ICDDMS'=0 D  G END
- . I ICDDATE>3070930.9 S ICDRG=$S(ICDDMS="":999,1:894) Q
- . S ICDRG=$S(ICDDMS="":470,1:433)
- I ICDMDC=22 S ICDRTC=$S(ICDTRS="":6,1:"") S:ICDRTC'="" ICDRG=$S(ICDDATE>3070930.9:999,1:470) D:ICDRTC="" CKBURN G END
- I ICDMDC=15 S ICDRTC=$S(ICDEXP="":5,ICDTRS="":6,1:"") I ICDTRS'=0 D  G END
- . I ICDDATE>3070930.9 S ICDRG=$S(ICDRTC'="":999,1:789) Q
- . S ICDRG=$S(ICDRTC'="":470,1:385)
-NEONATE I 'ICDNOR!('$D(ICDODRG)) S ICDRG=$O(ICDPDRG(0)) X "I ICDMDC=15,$D(ICDSDRG),$O(ICDSDRG(0))<ICDRG D NEONATF^ICDDRG0" D  D DODRG G GETMOR:ICDRG="",END
+ I ICDMDC=20 S ICDRTC=$S(ICDDMS="":7,1:"") I ICDDMS'=0 S ICDRG=$S(ICDDMS="":470,1:433) G END
+ I ICDMDC=22 S ICDRTC=$S(ICDTRS="":6,1:"") S:ICDRTC'="" ICDRG=470 D:ICDRTC="" CKBURN G END
+ I ICDMDC=15 S ICDRTC=$S(ICDEXP="":5,ICDTRS="":6,1:"") I ICDTRS'=0 S ICDRG=$S(ICDRTC'="":470,1:385) G END
+NEONATE I 'ICDNOR!('$D(ICDODRG)) S ICDRG=$O(ICDPDRG(0)) X "I ICDMDC=15,$D(ICDSDRG),$O(ICDSDRG(0))<ICDRG S ICDRG=$S($D(ICDPDRG(391)):391,$D(ICDPDRG(387)):387,1:$O(ICDSDRG(0)))" D  D DODRG G GETMOR:ICDRG="",END
  . N X,X1,X2,%
  . S X1=$S($G(DGADM):$G(DGADM),1:DT),X2=$G(DOB) I X1,X2 D ^%DTC I X<29 D NBCOMP Q
- . I ICDDATE'>3070930.9 I ICDRG<385!(ICDRG>391) Q
- . I ICDDATE>3070930.9 I ICDRG<789!(ICDRG>795) Q
+ . I ICDRG<385!(ICDRG>391) Q
  .; I "^11917^11918^11921^"[("^"_ICDDX(1)_"^") S ICDRG=395 Q
- . I ICDDATE'>3070930.9 I $O(ICDRG(391)) S ICDRG=$O(ICDRG(391)) Q
- . I ICDDATE>3070930.9 I $O(ICDRG(795)) S ICDRG=$O(ICDRG(795)) Q
- . I 'ICDRG S ICDRG=$S(ICDDATE>3070930.9:999,1:470),ICDRTC=8
- I AGE="",ICDMDC=3 S ICDRTC=3 S ICDRG=$S(ICDDATE>3070930.9:999,1:470) G END
+ . I $O(ICDRG(391)) S ICDRG=$O(ICDRG(391)) Q
+ . I 'ICDRG S ICDRG=470,ICDRTC=8
+ I AGE="",ICDMDC=3 S ICDRTC=3,ICDRG=470 G END
  D ^ICDDRG1:ICDMDC=1,^ICDDRG2:ICDMDC=2,^ICDDRG3:ICDMDC=3,^ICDDRG5:ICDMDC=5,^ICDDRG6:ICDMDC=6,^ICDDRG7:ICDMDC=7,^ICDDRG8:ICDMDC=8,^ICDDRG9:ICDMDC=9,^ICDDRG10:ICDMDC=10,^ICDDRG11:ICDMDC=11,^ICDDRG12:ICDMDC=12,^ICDDRG13:ICDMDC=13
  D ^ICDDRG17:ICDMDC=17
@@ -53,6 +44,6 @@
  D DODRG
  G:ICDRG'>0 LOOK8:ICDMDC=8,AGAIN G END
-ENTER I 'ICDNOR,ICDORNR'=0,ICDMDC'=20,ICDMDC'=15 S ICDRG=$S(ICDDATE>3070930.9:983,1:468) G END
-GETMOR S (ICDRG,HICDRG)=$O(ICDPDRG(0)) S:ICDRG'>0 (ICDRG,HICDRG)=$S(ICDDATE>3070930.9:998,1:469)
+ENTER I 'ICDNOR,ICDORNR'=0,ICDMDC'=20,ICDMDC'=15 S ICDRG=468 G END
+GETMOR S (ICDRG,HICDRG)=$O(ICDPDRG(0)) S:ICDRG'>0 (ICDRG,HICDRG)=469 ;I ICDMDC=15,'$D(ICDODRG),$D(ICDSDRG),$O(ICDSDRG(0))<ICDRG S (ICDRG,HICDRG)=$O(ICDSDRG(0))
 CKDRG D DODRG
  I ICDRG="" K ICDPDRG(HICDRG) G GETMOR
@@ -61,5 +52,5 @@
  N DRGFY,ICDREF S (DRGFY,ICDREF)=""
  I ICDRG S DRGFY=$O(^ICD(ICDRG,2,"B",$P(+$G(ICDDATE),".")_.01),-1)
- I 'DRGFY S DRGFY=3071001 ;default to current fiscal year
+ I 'DRGFY S DRGFY=3061001 ;default to current fiscal year
  S ICDREF=$O(^ICD(+ICDRG,2,"B",+DRGFY,ICDREF))
  I ICDREF'="" D
@@ -75,64 +66,44 @@
  D:ICDP24'=""!($D(ICDS24)) CKMST^ICDDRGX S ICDDRG=ICDRG
  ;ICD*18*24 check for higher numbered DRG (such as new DRG 561) before checking for 489 in CKHIV^ICDDRGX
- I ICDDATE<3071001 I ICDRG=489!(ICDRG=490)!(ICDRG=543&($G(ICDOR)="")) S ICDRG=$P($G(ICDPDRG),U,2) I ICDRG=543 S ICDRG=561
- I ICDDATE'<3071001 I ICDRG=976!(ICDRG=977)!(ICDRG=24&($G(ICDOR)="")) S ICDRG=$P($G(ICDPDRG),U,2) I ICDRG=24 S ICDRG=99
+ I ICDRG=489!(ICDRG=490)!(ICDRG=543&($G(ICDOR)="")) S ICDRG=$P($G(ICDPDRG),U,2) I ICDRG=543 S ICDRG=561
  D:$G(ICDP25)=1!(($G(ICDP25)>1)&($D(ICDS25(1)))) CKHIV^ICDDRGX S ICDDRG=ICDRG
  ; this will effectively make DRG 103 into a pre-MDC (ICD*18*1)
- I $D(ICDOP(" 33.6"))!$D(ICDOP(" 37.5"))!(ICDDATE>3030930.9&($D(ICDOP(" 37.51"))!$D(ICDOP(" 37.66")))) S ICDRG=$S(ICDDATE>3070930.9:2,1:103),ICDNMDC(1)="" D DODRG
- I (ICDDATE>3050930.9)&($D(ICDOP(" 37.64")))&($D(ICDOP(" 37.65"))) S ICDRG=$S(ICDDATE>3070930.9:2,1:103),ICDNMDC(1)="" D DODRG
- I (ICDDATE>3060930.9)&($D(ICDOP(" 37.63")))&($D(ICDOP(" 37.64"))) S ICDRG=$S(ICDDATE>3070930.9:2,1:103),ICDNMDC(1)="" D DODRG
- I $D(ICDOP(" 39.65")) S ICDRG=$S(ICDDATE>3070930.9:3,1:541),ICDNMDC(1)=""
- I (ICDDATE>3070930.9)&($D(ICDOP(" 46.97"))) S ICDRG=5,ICDNMDC(1)=""
+ I $D(ICDOP(" 33.6"))!$D(ICDOP(" 37.5"))!(ICDDATE>3030930.9&($D(ICDOP(" 37.51"))!$D(ICDOP(" 37.66")))) S ICDRG=103,ICDNMDC(1)=""
+ I (ICDDATE>3050930.9)&($D(ICDOP(" 37.64")))&($D(ICDOP(" 37.65"))) S ICDRG=103,ICDNMDC(1)=""
+ I (ICDDATE>3060930.9)&($D(ICDOP(" 37.63")))&($D(ICDOP(" 37.64"))) S ICDRG=103,ICDNMDC(1)=""
+ I $D(ICDOP(" 39.65")) S ICDRG=541,ICDNMDC(1)=""
  ; this will create DRGs 512/513 as pre-MDC
- I $D(ICDOP(" 52.80"))!$D(ICDOP(" 52.82")) S ICDRG=$S(ICDDATE>3070930.9:10,1:513),ICDNMDC(1)=""
- I (ICDDATE>3070930.9) D
- . I ICDRG=10 I $D(ICDOP(" 55.69")) S ICDRG=8
- E  I ICDRG=513 I $D(ICDOP(" 55.69")) S ICDRG=512
+ I $D(ICDOP(" 52.80"))!$D(ICDOP(" 52.82")) S ICDRG=513,ICDNMDC(1)=""
+ I ICDRG=513 I $D(ICDOP(" 55.69")) S ICDRG=512
  ; this will create DRG 481 as pre-MDC - loops thru 41.00 thru .09
- N X S X=0 F  S X=$O(ICDOP(X)) Q:X=""  I X["41.0" S ICDRG=$S(ICDDATE>3070930.9:9,1:481),ICDNMDC(1)=""
+ N X S X=0 F  S X=$O(ICDOP(X)) Q:X=""  I X["41.0" S ICDRG=481,ICDNMDC(1)=""
  I $D(ICDNMDC(1)) I ICDNMDC(1)="" D CKNMDC^ICDDRGX S ICDDRG=ICDRG K ICDNMDC
- I ICDDATE>3070930.9 D
- . I ICDRG=983 D CHKMDC4^ICDDRGX
- . D DODRG S ICDDRG=ICDRG ;check for MCC/CC
- E  I ICDRG=468 D CHKMDC4^ICDDRGX D DODRG S ICDDRG=ICDRG
+ I ICDRG=468 D CHKMDC4^ICDDRGX D DODRG S ICDDRG=ICDRG
  S:ICDRTC="" ICDRTC=0
- S ICDTMP=$$DRG^ICDGTDRG(ICDDRG,ICDDATE) I '$P(ICDTMP,U,14) S ICDDRG=$S(ICDDATE>3070930.9:999,1:470)
+ S ICDTMP=$$DRG^ICDGTDRG(ICDDRG,ICDDATE) I '$P(ICDTMP,U,14) S ICDDRG=470
  G KILL^ICDDRG
 MI ;
  ; if PTCA and not a bypass
- I ICDOR["1"!($D(ICDOP(" 37.90"))) I ICDOR'["b"&(ICDOR'["6") D  Q
- . I ICDDATE>3070930.9 D CMS516^ICDTBL2 Q
- . E  D DRG516^ICDTLB6B
+ I ICDOR["1"!($D(ICDOP(" 37.90"))) I ICDOR'["b"&(ICDOR'["6") I ICDDATE>3050930.9 D DRG516^ICDTLB6B Q
  I ICDPD["A" D EN1^ICDDRG5 I ICDCC3 S ICDRG=$O(ICDODRG(0)) D DODRG Q
  I ICDPD["AI"!(ICDSD["AI") D  Q
- . I ICDDATE>3070930.9 D
- . . S ICDRG=$S($S($D(ICDEXP):ICDEXP,1:0):285,ICDPD["V"!(ICDSD["V"):280,1:282)
- . E  D 
- . . I $D(ICDOP(" 36.07")) I $D(ICDOP(" 37.26"))!($D(ICDOP(" 37.27"))) S ICDRG=526 Q
- . . S ICDRG=$S($S($D(ICDEXP):ICDEXP,1:0):123,ICDPD["V"!(ICDSD["V"):121,1:122)
- I $D(ICDOP(" 37.26"))&($D(ICDOP(" 39.61"))) S ICDRG=$S(ICDDATE>3070930.9:230,1:108) Q
+ . I $D(ICDOP(" 36.07")) I $D(ICDOP(" 37.26"))!($D(ICDOP(" 37.27"))) S ICDRG=526 Q
+ . S ICDRG=$S($S($D(ICDEXP):ICDEXP,1:0):123,ICDPD["V"!(ICDSD["V"):121,1:122)
+ I $D(ICDOP(" 37.26"))&($D(ICDOP(" 39.61"))) S ICDRG=108 Q
  ;I $D(ICDOP(" 37.26")) S ICDRG=112 Q
- I ICDDATE<3071001 I $D(ICDOP(" 36.07")) I $D(ICDOP(" 37.26"))!($D(ICDOP(" 37.27"))) S ICDRG=527 Q
- I ICDDATE<3071001 I $D(ICDOP(" 36.06")) I $D(ICDOP(" 37.26"))!$D(ICDOP(" 37.27")) S ICDRG=517 Q
- I $D(ICDOP(" 37.26"))!$D(ICDOP(" 37.27")) S ICDRG=$S(ICDDATE>3070930.9:251,1:518) Q
- I ICDOR["H" D  Q
- . I ICDDATE>3070930.9  S ICDRG=$S(ICDPD["X"!(ICDSD["X"):286,1:287) Q
- . E  S ICDRG=$S(ICDPD["X"!(ICDSD["X"):124,1:125) Q
- I ICDDATE>3070930.9 K ICDPDRG(286),ICDPDRG(287)
- E  K ICDPDRG(124)
+ I $D(ICDOP(" 36.07")) I $D(ICDOP(" 37.26"))!($D(ICDOP(" 37.27"))) S ICDRG=527 Q
+ I $D(ICDOP(" 36.06")) I $D(ICDOP(" 37.26"))!$D(ICDOP(" 37.27")) S ICDRG=517 Q
+ I $D(ICDOP(" 37.26"))!$D(ICDOP(" 37.27")) S ICDRG=518 Q 
+ I ICDOR["H" S ICDRG=$S(ICDPD["X"!(ICDSD["X"):124,1:125) Q
+ K ICDPDRG(124)
  I ICDOR["p" S ICDRG=$O(ICDODRG(0)) D DODRG Q
  I ICDOR["F" S ICDRG=$O(ICDODRG(0)) D DODRG Q
- E  D  Q
- . I ICDDATE>3070930.9 K ICDPDRG(280),ICDPDRG(281),ICDPDRG(282) S ICDRG=$O(ICDPDRG(0)) D DODRG Q
- . E  K ICDPDRG(121) S ICDRG=$O(ICDPDRG(0)) D DODRG Q
+ E  K ICDPDRG(121) S ICDRG=$O(ICDPDRG(0)) D DODRG Q
  ;
 CKBURN ; MDC22 - Burns (extensive, full thickness, or non-extensive)
  D
- . I ICDPD["*"!(ICDSD["*") D  Q
- . . I ICDDATE>3070930.9 S ICDRG=$S(ICDOR["k":927,1:933) Q
- . . E  S ICDRG=$S(ICDOR["k":504,1:505) Q
+ . I ICDPD["*"!(ICDSD["*") S ICDRG=$S(ICDOR["k":504,1:505) Q
  . I ICDPD["b"!(ICDSD["b") D FTBURN Q
- . I ICDDATE>3070930.9 S ICDRG=$S(ICDCC!(ICDPD["T")!(ICDSD["T"):935,1:935)
- . E  S ICDRG=$S(ICDCC!(ICDPD["T")!(ICDSD["T"):510,1:511)
+ . S ICDRG=$S(ICDCC!(ICDPD["T")!(ICDSD["T"):510,1:511)
  Q
  ;
@@ -151,23 +122,14 @@
  N ICDSDXCK
  S ICDSDXCK=$O(ICDSDRG(0))
- I ICDDATE>3070930.9 D
- . I ICDSDXCK<ICDRG,ICDSDXCK>788,ICDSDXCK<796 D
- .. S ICDRG=$S($D(ICDPDRG(795)):795,$D(ICDPDRG(791)):791,1:$O(ICDSDRG(0)))
- E  D
- . I ICDSDXCK<ICDRG,ICDSDXCK>384,ICDSDXCK<392 D
- .. S ICDRG=$S($D(ICDPDRG(391)):391,$D(ICDPDRG(387)):387,1:$O(ICDSDRG(0)))
+ I ICDSDXCK<ICDRG,ICDSDXCK>384,ICDSDXCK<392 D
+ . S ICDRG=$S($D(ICDPDRG(391)):391,$D(ICDPDRG(387)):387,1:$O(ICDSDRG(0)))
  Q
  ;
 FTBURN ; full thickness burn check
  I ICDSD["j"!(ICDOR["k") D
- . I ICDCC!(ICDPD["T")!(ICDSD["T") S ICDRG=$S(ICDDATE>3070930.9:928,1:506)
- . E  S ICDRG=$S(ICDDATE>3070930.9:929,1:507)
+ . I ICDCC!(ICDPD["T")!(ICDSD["T") S ICDRG=506
+ . E  S ICDRG=507
  E  D
- . I ICDCC!(ICDPD["T")!(ICDSD["T") S ICDRG=$S(ICDDATE>3070930.9:934,1:508)
- . E  S ICDRG=$S(ICDDATE>3070930.9:934,1:509)
+ . I ICDCC!(ICDPD["T")!(ICDSD["T") S ICDRG=508
+ . E  S ICDRG=509
  Q
- ;
-NEONATF ;NEONATE - Continuation of xecute line
- I ICDDATE>3070930.9 S ICDRG=$S($D(ICDPDRG(795)):795,$D(ICDPDRG(791)):791,1:$O(ICDSDRG(0))) Q
- S ICDRG=$S($D(ICDPDRG(391)):391,$D(ICDPDRG(387)):387,1:$O(ICDSDRG(0)))
- Q
Index: FOIAVistA/tag/r/DRG_GROUPER-ICD--ICPT/ICDDRG1.m
===================================================================
--- FOIAVistA/trunk/r/DRG_GROUPER-ICD--ICPT/ICDDRG1.m	(revision 631)
+++ FOIAVistA/tag/r/DRG_GROUPER-ICD--ICPT/ICDDRG1.m	(revision 636)
@@ -1,8 +1,7 @@
-ICDDRG1 ;ALB/MRY - FIX SURGERY HIERARCHY ; 11/14/07 5:30pm
- ;;18.0;DRG Grouper;**10,17,24,31**;Oct 20, 2000;Build 7
+ICDDRG1 ;ALB/MRY - FIX SURGERY HIERARCHY ; 6/15/05 7:07pm
+ ;;18.0;DRG Grouper;**10,17,24**;Oct 20, 2000;Build 5
  Q:$O(ICDODRG(0))'>0  K ICDJ F ICDJ=0:0 S ICDJ=$O(ICDODRG(ICDJ)) Q:ICDJ'>0  D
- . I ICDDATE<3061001 D F Q
- . E  I ICDDATE<3071001 D FY2007 Q
- . E  D FY2008
+ .I ICDDATE<3061001 D F
+ .E  D FY2007
 END S ICDJ=$O(ICDJ(0)) Q:ICDJ'>0  S ICDJ=ICDJ(ICDJ) K ICDODRG S ICDODRG(ICDJ)="" K ICDJ Q
 F I ICDJ=3 S ICDJ(1)=ICDJ Q
@@ -86,13 +85,2 @@
  I ICDJ=35 S ICDJ(39)=ICDJ Q
  Q
-FY2008 ;MS-DRG
- I ICDJ=27 S ICDJ(1)=ICDJ Q
- I ICDJ=22 S ICDJ(2)=ICDJ Q
- I ICDJ=24 S ICDJ(3)=ICDJ Q
- ;I ICDJ=27 S ICDJ(3)=ICDJ Q
- I ICDJ=30 S ICDJ(4)=ICDJ Q
- I ICDJ=33 S ICDJ(5)=ICDJ Q
- I ICDJ=36 S ICDJ(6)=ICDJ Q
- I ICDJ=39 S ICDJ(7)=ICDJ Q
- I ICDJ=42 S ICDJ(8)=ICDJ Q
- Q
